#!/usr/bin/perl -w
# 2007-02-08 onohiroki@cup.com http://onohiroki.cycling.jp/
use strict;
foreach (@ARGV) {
   get_filename_and_do ($_);
}

sub get_filename_and_do {
   my $input = shift @_;
   use File::Basename qw/ basename dirname/;
   my $basename = basename $input;
   my $dirname = dirname $input;
   return if ($basename =~ m/s*.vcss*$/i);
   $basename =~ s/s*.icss*$//i;
   $basename = "$basename.vcs";
   use File::Spec;
   my $outfile = File::Spec->catfile($dirname,$basename);
   ics2vcs($input, $outfile);
}

sub ics2vcs {
   my $inputfile = shift @_;
   my $outputfile = shift @_;
   unless (open INPUTICS, "<$inputfile") {
      die "Cannot Open file: $!";
   }
   
   my $summary = "eXgT}[";
   my $description = "eXgfXNvV";
   my $dtstart = "20070107T12:00";
   my $dtend = "20070107T12:00";
   my $location = q{};
   my $url = q{};
   while (<INPUTICS>) {
      last if (m/BEGIN:VEVENT/);
   }
   while (<INPUTICS>) {
      $summary = $1 if (m/SUMMARY[^:]*:(.*)/);
      $location = $1 if (m/LOCATION[^:]*:(.*)/);
      $url = $1 if (m/URL[^:]*:(.*)/);
      if (m/DESCRIPTION[^:]*:(.*)/) {
        $description = $1;
        while (<INPUTICS>) {
           last unless (m/^s/);
           $description = $description.$_;
        }
      }
      $dtstart = $1 if (m/DTSTART[^:]*:(.*)/);
      $dtend = $1 if (m/DTEND[^:]*:(.*)/);
      #print;
   }
   $description = "$location $description $url";
   $description =~ s/n/ /gi;
   $description =~ s/x0D|x0A//gi;
   $description =~ s/@+/ /gi;
   $description =~ s/s+/ /gi;
   
my $vcal = << "__END_VCALENDAR__";
BEGIN:VCALENDAR
VERSION:1.0
TZ:+09:00
DAYLIGHT:FALSE
BEGIN:VEVENT
SUMMARY;CHARSET=UTF-8:$summary
DESCRIPTION;CHARSET=UTF-8:$description
CLASS:PUBLIC
DTSTART:$dtstart
DTEND:$dtend
AALARM:
CATEGORIES:
RRULE:
END:VEVENT
END:VCALENDAR
__END_VCALENDAR__
   close INPUTICS;
   unless (open VCSOUTPUT, ">$outputfile") {
      die "Cannot Open file: $!";
   }
   print VCSOUTPUT $vcal;
   close VCSOUTPUT;
}

